# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .concept_label_enum import ConceptLabelEnum
from .image import Image
from .keyframe import Keyframe

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ConceptLabel(pydantic.BaseModel):
    """
    An association of an image or video keyframe to a concept
    """

    label_id: str = pydantic.Field(alias="labelId", description="The label id")
    label: ConceptLabelEnum = pydantic.Field(description="The label for the image or video keyframe")
    image: typing.Optional[Image] = pydantic.Field(
        description="The labelled image (if the labelled image is not a video keyframe)"
    )
    keyframe: typing.Optional[Keyframe] = pydantic.Field(
        description="The labelled video keyframe (if the labelled image is a video keyframe)"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
